// ======================================================================
//
// writebmp.cpp
// jeff grills
//
// copyright 1997 origin systems inc
//
// ======================================================================

#include "first.h"
#include "writebmp.h"

#include <stdio.h>

// ======================================================================

void writeBMP(const char *filename, const RGB *rgb, int width, int height)
{
	BITMAPFILEHEADER fileHeader;
	BITMAPINFOHEADER infoHeader;
	int              w;
	u_int8          *bgr, *d;
	const RGB       *s;
	FILE            *file;

	// create the file
	file = fopen(filename, "wb");
	if (file)
	{
		// setup the file header
		fileHeader.bfType = 'MB';
		fileHeader.bfSize = sizeof(fileHeader) + sizeof(infoHeader) + (3 * width * height);
		fileHeader.bfReserved1 = 0;
		fileHeader.bfReserved1 = 0;
		fileHeader.bfOffBits = sizeof(fileHeader) + sizeof(infoHeader);
		fwrite(&fileHeader, sizeof(fileHeader), 1, file);

		// setup the bitmap header
		infoHeader.biSize = sizeof(infoHeader);
		infoHeader.biWidth = width;
		infoHeader.biHeight = height;
		infoHeader.biPlanes = 1;
		infoHeader.biBitCount = 24;
		infoHeader.biCompression = BI_RGB;
		infoHeader.biSizeImage = 0;
		infoHeader.biXPelsPerMeter = 1;
		infoHeader.biYPelsPerMeter = 1;
		infoHeader.biClrUsed = 0;
		infoHeader.biClrImportant = 0;
		fwrite(&infoHeader, sizeof(infoHeader), 1, file);
	
		bgr = NEW u_int8[width * 3];
		while (height--)
		{
			for (w = width, d = bgr, s = rgb+(width * height); w--; d += 3, s++)
			{
				d[2] = s->r;
				d[1] = s->g;
				d[0] = s->b;
			}
			
			fwrite(bgr, 1, width * 3, file);
		}

		fclose(file);

		delete [] bgr;
	}
}

// ======================================================================
